/*
This program has been developed by students from the bachelor Computer Science at Utrecht University within the Software Project course.
© Copyright Utrecht University (Department of Information and Computing Sciences)
*/

package main

import (
	"encoding/json"
	"log"

	"git.science.uu.nl/graphpolaris/query-conversion/aql"
	"git.science.uu.nl/graphpolaris/query-conversion/entity"
)

/*
The main function that calls the appropriate functions
*/
func main() {
	queryservice := aql.NewService()

	js := []byte(`{
        "databaseName": "test",
        "return": {
          "entities": [
            0,
            1,
            2,
            3
          ],
          "relations": [
            0,
            1
          ]
        },
        "entities": [
          {
            "type": "kamerleden",
            "constraints": []
          },
          {
            "type": "partijen",
            "constraints": []
          }
          ,
          {
            "type": "kamerleden",
            "constraints": []
          },
          {
            "type": "commissies",
            "constraints": []
          }
        ],
        "relations": [
          {
            "type": "lid_van",
            "depth": {
              "min": 1,
              "max": 1
            },
            "entityFrom": 0,
            "entityTo": 1,
            "constraints": []
          },
          {
            "type": "onderdeel_van",
            "depth": {
              "min": 1,
              "max": 1
            },
            "entityFrom": 2,
            "entityTo": 3,
            "constraints": []
          }
        ],
        "limit": 5000,
        "modifiers": []
      }`)

	var inc entity.IncomingQueryJSON
	json.Unmarshal(js, &inc)
	result, _ := queryservice.ConvertQuery(&inc)
	log.Println(*result)
}
